#include "diawxxt.h"

class MFORM_CLIST: public MFORM{
	CLIST *cl;
public:
	MFORM_CLIST(CLIST *_cl)
		: MFORM (_cl,""){
		cl = _cl;
	}
	void hmoveitems(int newpos){
		MFORM::hmoveitems (newpos);
		if (cl->hoffset != hoffset){
			cl->hoffset = hoffset;
			cl->drawhead();
		}
	}
	void OnPaint(){
			SetBackground (brush_white);
			dc->SetBackground (brush_white);
			dc->Clear();
#if 0
fprintf (stderr,"clist paint %d\n",nbc);
static int coo=0;
coo++;
if (coo == 4){
	char *pt = NULL;
	*pt = '\0';
}
#endif
			MFORM::OnPaint();
	}
	void OnEvent(wxMouseEvent & event){
		#if 0
			if (event.Entering()){
				fprintf (stderr,"Entering\n");
				SetFocus();
			}else if (event.Leaving()){
				fprintf (stderr,"Leaving\n");
			}
		#endif
		MFORM::OnEvent(event);
	}
};


PUBLIC CLIST::CLIST (
	FORMBASE *_parent,
	const char *_id,
	int _nbcol,
	const char *_cols[])
	: MFORM (_parent,_id)
{
	sub = new MFORM_CLIST(this);
	int nbline = rem_getvarval ("vsize");
	if (nbline == -1){
		sub->max_height = 200;
	}else{
		sub->max_height = ((int)GetCharHeight()+2)*nbline;
	}
	sub->max_width = 600;
	max_width = 2600;
	max_height = 2200;
	New_form(sub);
	Setweightlast (1,1);
	nbcol = _nbcol;
	cols = new char *[_nbcol];
	wxDC *dc = GetDC();
	int maxh = 0;
	for (int i=0; i<_nbcol; i++){
		const char *s = _cols[i];
		cols[i] = strdup(s);
		float w,h;
		dc->GetTextExtent (s,&w,&h);
		int wi = (int)w+5;
		int hi = (int)h;
		sub->mincols[i] = wi;
		if (hi > maxh) maxh = hi;
	}
	// marge_droite = marge_gauche = 5;
	marge_haut = maxh + 5;
	// marge_bas = 5;
}

PUBLIC CLIST::~CLIST ()
{
	for (int i=0; i<nbcol; i++){
		free (cols[i]);
	}
	delete [] cols;
}

/*
	Add a new line
*/
PUBLIC void CLIST::New_item (const char *id, const char *items[])
{
	for (int i=0; i<nbcol; i++){
		sub->New_buttonfill (id,items[i],MFORM_OPTFLAT);
	}
	sub->Newline();
}
/*
	Set the value of an existing line or add a new line
*/
PUBLIC void CLIST::Set_item (const char *id, const char *items[])
{
	bool found = false, redo=false;
	for (int i=0; i<sub->nbc; i++){
		MFORM_C *c = sub->tbc[i];
		if (strcmp(c->id,id)==0){
			found = true;
			for (int j=0; j<nbcol; j++){
				MFORM_C *n = sub->tbc[i+j];
				n->sets (items[j]);
				float w,h;
				dc->GetTextExtent (n->s,&w,&h);
				int wi = (int)w;
				if (n->width < wi) redo = true;
			}
			if (!redo){
				sub->drawitems (i,i+nbcol,true);
			}
			break;
		}
	}
	if (!found) New_item (id,items);
	if (!found || redo){
		gettop()->mainlayout();
	}
}

/*
	Draw the heading of the list and the decoration around the list.
*/
PUBLIC void CLIST::drawhead()
{
	wxDC *dc = GetDC();
	// Clear the header area
	dc->SetPen (pen_back);
	dc->SetBrush (brush_back);
	int cwidth,cheight;
	GetSize (&cwidth,&cheight);
	dc->DrawRectangle (0,0,cwidth,marge_haut);

	int x = 8 - hoffset;
	float w,h;
	dc->GetTextExtent ("WWW",&w,&h);
	int y = (int)h+2;
	for (int i=0; i<nbcol; i++){
		dc->SetPen (pen_black);
		dc->DrawText (cols[i],x,0);
		int width = sub->colwidth[i];
		dc->DrawLine (x,y,x+width-4,y);
		x += width;
	}
}
PUBLIC void CLIST::OnPaint()
{
	MFORM::OnPaint();
	drawhead();
}


PUBLIC int CLIST::setcurfield (
	const char *id_suffix,
	wxWindow *tbfocus[],
	int &nbfocus)
{
	// fprintf (stderr,"CLIST curfield :%s:\n",id_suffix);
	int ret = -1;
	for (int i=0; i<sub->nbc; i++){
		MFORM_C *c = sub->tbc[i];
		// fprintf (stderr,"clist cmp :%s: :%s:\n",c->id,id_suffix);
		if (strcmp(c->id,id_suffix)==0){
			ret = 0;
			int w,h;
			sub->GetSize (&w,&h);
			// fprintf (stderr,"sub voffset %d h %d y %d\n",sub->voffset,h,c->y);
			int charh2 = (int)GetCharHeight()*2;
			if (c->y < 0){
				sub->vmoveitems(sub->voffset+c->y);
			}else if (c->y + charh2 > h){
				sub->vmoveitems (sub->voffset+c->y-h+charh2);
			}
			// fprintf (stderr,"sub voffset %d h %d y %d\n",sub->voffset,h,c->y);
			tbfocus[nbfocus++] = sub;
			tbfocus[nbfocus++] = this;
			break;
		}
	}
	return ret;
}

PUBLIC void CLIST::setval(
	const char *id,
	const char *vals[],
	SETVAL_INFO &info)
{
	Set_item (id,vals);
}


