
/*
 Wineconf 1.0 -- Linuxconf module for Wine configuration
 by Daniel Mealha Cabrita (dancab@conectiva.com)
 */

#include <stdio.h>
#include <string.h>
#include "wineconf.h"
#include "wineconf.m"

#include "wineconf_global_defs.h"
#include "wineconf_menu_drives.cc"
#include "wineconf_internal_dirs.cc"
#include "wineconf_devices.cc"
#include "wineconf_advanced.cc"
#include "wineconf_appbehaviour.cc"

void manage_main_window(CONFIG_FILE &cf_wineconf, int needs_root_access)
{
    VIEWITEMS_PARSER pre_vitems_wineconf;
    VIEWITEMS vitems_wineconf(pre_vitems_wineconf);
    MENU_STATUS my_button=MENU_STATUS(0);
    int    my_selection=0;
    DIALOG_MENU dia_mymenu;
    int    may_i_enter=0;

    pre_vitems_wineconf.linecont=false;
    vitems_wineconf.read(cf_wineconf);// load variables with data from file

    dia_mymenu.new_menuitem("", MSG_U(M_DRIVESASSIGNMENTS, "Virtual Drives"));
    dia_mymenu.new_menuitem("", MSG_U(M_INTERNALDIRS, "Internal Directories"));
    dia_mymenu.new_menuitem("", MSG_U(M_DEVICES, "Assigned devices"));
    dia_mymenu.new_menuitem("", MSG_U(M_APPSBEHAVIOUR, "Application behavior under Wine")); // includes appearance config
    dia_mymenu.new_menuitem("", MSG_U(M_ADVOPTS, "Advanced options"));
//    dia_mymenu.new_menuitem("", "Easy Configuration");

    while(1){
//        MSG_U(I_WINECONFIGURATOR, "If you're configurating Wine for the first time\nyou may want to try the \"Easy Configuration\" option below.")
        my_button=dia_mymenu.editmenu(MSG_U(T_WINECONFIGURATOR, "Wine configurator"), "", help_nil, my_selection, MENUBUT_QUIT);
        if((my_button==MENU_QUIT)||(my_button==MENU_ESCAPE))
            return;

        /* user selected some menu option.. */

        if(needs_root_access){
            if(perm_rootaccess(""))
                may_i_enter=1;
        } else {
            may_i_enter=1;
        }

        if(may_i_enter){
            switch(my_selection){
            case 0:
                manage_drives_settings(vitems_wineconf, cf_wineconf);
                break;
            case 1:
                manage_internal_directories_settings(vitems_wineconf, cf_wineconf);
                break;
            case 2:
                manage_devices_settings(vitems_wineconf, cf_wineconf);
                break;
            case 3:
                manage_application_behaviour(vitems_wineconf, cf_wineconf);
                break;
            case 4:
                manage_advanced_options(vitems_wineconf, cf_wineconf);
                break;
            case 5:
            //            easy_configuration_menu();
                break;
            }
        }
    }
}

/* this function is currently useless (but it's pretty, so i kept it here) */
void edit_home_or_etc(void)
{
    MENU_STATUS my_button=MENU_STATUS(0);
    int    my_selection=0;
    DIALOG_MENU dia_mymenu;

    dia_mymenu.new_menuitem("", "Edit global configurations");
    dia_mymenu.new_menuitem("", "Edit user configurations");

    while(1){
        my_button=dia_mymenu.editmenu("Select configuration", "", help_nil, my_selection, MENUBUT_QUIT);
        if((my_button==MENU_QUIT)||(my_button==MENU_ESCAPE))
            return;

        switch(my_selection){
        case 0:
            manage_main_window(cf_etcwineconf, 1);
            break;
        case 1:
//            manage_main_window(cf_homewineconf);
            manage_main_window(cf_etcwineconf, 0);
            break;
        }
    }
}

void start_things(void)
{
    //    edit_home_or_etc();
    manage_main_window(cf_etcwineconf, 1);
}

